﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace MakeGirdShape
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            XrMapLib.FieldSetDefine FSD = new XrMapLib.FieldSetDefine();
            FSD.AddIntegerField("Row", 4);
            FSD.AddIntegerField("Column", 4);

            XrMapLib.Tool tool = new XrMapLib.Tool();
            XrMapLib.EsriShpFileHandler SFH = tool.CreateEsriShpFileHandler(tbShpFile.Text, XrMapLib.XrShapeTypeEnum.XrPolygon, FSD);

            if (SFH == null)
            {
                MessageBox.Show("Error: Creating shp file");
            }
            else
            {
                XrMapLib.CoordinateList CL = new XrMapLib.CoordinateList();
                XrMapLib.ValueList VL = new XrMapLib.ValueList();

                double MinX = double.Parse(tbMinX.Text);
                double MinY = double.Parse(tbMinY.Text);
                double MaxX = double.Parse(tbMaxX.Text);
                double MaxY = double.Parse(tbMaxY.Text);
                int ColumnCount = int.Parse(tbColumnCount.Text);
                int RowCount = int.Parse(tbRowCount.Text);
                double GridWidth = (MaxX - MinX) / (double)ColumnCount;
                double GridHeight = (MaxY - MinY) / (double)RowCount;

                for (int Row = 0; Row < RowCount; Row++) 
                {
                    for (int Column = 0; Column < ColumnCount; Column++) 
                    {
                        CL.Clear();
                        CL.Add(MinX + Column * GridWidth, MinY + Row * GridHeight);
                        CL.Add(MinX + (Column + 1) * GridWidth, MinY + Row * GridHeight);
                        CL.Add(MinX + (Column + 1) * GridWidth, MinY + (Row + 1) * GridHeight);
                        CL.Add(MinX + Column * GridWidth, MinY + (Row + 1) * GridHeight);
                        CL.Add(MinX + Column * GridWidth, MinY + Row * GridHeight);

                        VL.Clear();
                        VL.AddByInteger(Row);
                        VL.AddByInteger(Column);

                        SFH.AddSinglePart(CL, VL);
                    }
                }

                SFH.Close();
                Close();
            }
        }
    }
}
